# Funksjon for analyse av ip-ranges:
function Analyse_IPRange {

    [CmdletBinding()]

    # Parameteret er data som ønskes å analyseres:
    param ($enhet)

    # Navnet tilsvarer trusselID.
    $analyseNavn = 2
    $resultat = $true

    # Henter ut nyeste informasjon om enheten
    $uthenting = $enhet[$enhet.count - 1]

        $sccmIP = $uthenting.SCCM_IPLok
        $cppmIP = $uthenting.CPPM_IPLok
        $ampIP = $uthenting.AMP_IPLok

        # Sjekker om enheten har sccm-ip
        if ($null -ne $sccmIP) {
            # Looper gjennom hver ip fra enheten i sccm og sjekker om informasjon stemmer i AMP og CPPM
            foreach ($ip in $sccmIP) {
                if ($null -ne $cppmIP) {
                    if ($null -ne $ampIP) {
                        if ( ($ip -like $cppmIP) -and ($ip -like $ampIP) ) {
                            Write-Debug "SCCM_IP: $ip stemmer med AMP_IP: $ampIP og CPPM_IP: $cppm_ip"
                            $resultat = $false
                        }else {
                            Write-Debug "SCCM_IP: $ip stemmer ikke med AMP_IP: $ampIP eller CPPM_IP: $cppm_ip"
                        }
                    }else { 
                        Write-Debug "Enheten har CPPM IP men ingen AMP-IP"
                        if($ip -like $cppmIP){
                            Write-Debug "SCCM_IP: $ip stemmer med CPPM_IP: $cppm_ip"
                            $resultat = $false
                        }else{
                            Write-Debug "SCCM_IP: $ip stemmer ikke med CPPM IP: $cppm_ip"
                        }
                    }
                }else {
                    Write-Debug "Enheten har ingen CPPM-IP"
                    if ($null -ne $ampIP) {
                        if ( $ip -like $ampIP) {
                            Write-Debug "SCCM_IP: $ip stemmer med AMP_IP: $ampIP"
                            $resultat = $false
                        }else {
                        Write-Debug "SCCM_IP: $ip stemmer ikke med AMP:IP $ampIP"
                        }
                    }else { Write-Debug "Enheten har ingen AMP-IP eller CPPM IP"
                        $resultat = $false
                    }
                }
            }  
        }else {
            Write-Debug "Enheten har ingen sccm-IP"
            $resultat = $false
        }
    
        
    

    # Returnerer svaret av analysen:
     $out = ($analyseNavn, $resultat)
     $out
}