<#
    .Synopsis
    Funksjonen tar inn resultatet av Test-Enhetstabell, og formaterer det til å kunne sendes til group-sqlinnsending

    .Description
    Funksjonen tar inn ett objekt med analyseresultater fra Test-enhetstabell, og formaterer det til et objekt som kan sendes til group-sqlinnsending, og videre
    til new-sqlqueryenhetertrusler.
#>
function Format-AnalyseResultat {
    [CmdletBinding()]
    param (
        [Parameter(Mandatory, ValueFromPipeline)][Object[]]$analyseResultater
    )
    
    begin {
        #Initialiserer array som skal holde objektene
        $AnalyserteEnheter = @()
    }
    
    process {

        foreach ($analyseResult in $analyseResultater) {
            $MAC = $analyseresult[0]
            $Trussel_ID = $analyseresult[1]
            $status = $analyseresult[2]
            $dato = [datetime]::Now

            $tempObject = New-Object PSCustomObject
            $tempObject | Add-Member -NotePropertyName "Analyse_MAC" -NotePropertyValue $MAC
            $tempObject | Add-Member -NotePropertyName "Analyse_Trussel_ID" -NotePropertyValue $Trussel_ID
            $tempObject | Add-Member -NotePropertyName "Analyse_Status" -NotePropertyValue $status
            $tempObject | Add-Member -NotePropertyName "Analyse_Dato" -NotePropertyValue $dato

            $AnalyserteEnheter += $tempObject
        }
    }
    
    end {
        $AnalyserteEnheter
    }
}