<#
    .Synopsis
    Funksjonen henter alle uthentinger fra pathen, og returnerer en hashtable med alle uthentingene.

    .Description
    Funksjonen henter alle uthentinger fra pathen, og returnerer en hashtable med alle uthentingene. Funksjonen finner alle filer med file-extension .uthenting,
    som blir laget av Hent-utdata-scriptet. 
#>
function Get-HistoriskData {
    param (
        [parameter(Mandatory)][string]$pathTilUthentinger
    )
    
    $alleuthentinger = Get-ChildItem -Path $pathTilUthentinger | Where-Object -Property Name -Like "*.uthenting"

    $uthentinger = @()

    foreach ($uthenting in $alleuthentinger) {
        $tempHashTable = @{}
        $tempData = Get-Content -Path $uthenting.FullName | ConvertFrom-Json        
        $tempData.psobject.Properties | ForEach-Object { $tempHashTable[$_.Name] = $_.Value}
        $uthentinger += ,$tempHashTable
    }

    $uthentinger
}