﻿Function New-CPPMFakeData{
    [CmdletBinding()]
    param(
        [Parameter()][int]$count, 
        [Parameter(Mandatory)][hashtable]$macs,
        [Parameter()][DateTime]$now = [DateTime]::Now
    )

    $localMacs = $macs.Clone()
    $enheter = @()

    $deviceDetails = (
        @{
            device_category = "Computer";
            device_family = "Windows";
            device_family_name = "Windows 8/10"
        },
        @{
            device_category = "Computer";
            device_family = "Windows";
            device_family_name = "Windows Vista/7/2008"
        },
        @{
            device_category = "Server";
            device_family = "VMWare";
            device_family_name = "VMWare"
        },
        @{
            device_category = "Computer";
            device_family = "Windows";
            device_family_name = "Windows"
        }
    )

    For($i = 1; $i -le $count; $i++){
        $tempObject = New-Object PSCustomObject

        $mac = $localMacs.Keys | Get-Random
        
        $updateTime = New-RandomDate -max $now.AddDays(-1)

        $useProperIP = Get-Random -Minimum 0 -Maximum 8
        if($useProperIP -eq 0){
            $fullIP = New-RandomIP
            $iplok = "Unknown IPv4"
        }else{
            $ip = $localMacs."$mac"[0]
            $ipSuff = Get-Random -Minimum 10 -Maximum 250
            $fullIP = $ip + $ipSuff
            $iplok = $localMacs."$mac"[1]
        }
               
        $deviceDetail = Get-Random $deviceDetails
        $isOnline = Get-Random ("true", "false")
        
        $tempObject | Add-Member -NotePropertyName "CPPM_MAC" -NotePropertyValue $mac.ToUpper()
        $tempObject | Add-Member -NotePropertyName "CPPM_Updated_at" -NotePropertyValue $updateTime
        $tempObject | Add-Member -NotePropertyName "CPPM_ip" -NotePropertyValue $fullIP
        $tempObject | Add-Member -NotePropertyName "CPPM_IPLok" -NotePropertyValue $iplok
        $tempObject | Add-Member -NotePropertyName "CPPM_user" -NotePropertyValue ""
        $tempObject | Add-Member -NotePropertyName "CPPM_domain" -NotePropertyValue ""
        $tempObject | Add-Member -NotePropertyName "CPPM_roles" -NotePropertyValue "null"
        $tempObject | Add-Member -NotePropertyName "CPPM_spt" -NotePropertyValue "UNKNOWN"
        $tempObject | Add-Member -NotePropertyName "CPPM_device_category" -NotePropertyValue $deviceDetail.device_category
        $tempObject | Add-Member -NotePropertyName "CPPM_device_family" -NotePropertyValue $deviceDetail.device_family
        $tempObject | Add-Member -NotePropertyName "CPPM_device_name" -NotePropertyValue $deviceDetail.device_family_name
        $tempObject | Add-Member -NotePropertyName "CPPM_is_conflict" -NotePropertyValue "false"
        $tempObject | Add-Member -NotePropertyName "CPPM_other_category" -NotePropertyValue ""
        $tempObject | Add-Member -NotePropertyName "CPPM_other_family" -NotePropertyValue ""
        $tempObject | Add-Member -NotePropertyName "CPPM_other_name" -NotePropertyValue ""
        $tempObject | Add-Member -NotePropertyName "CPPM_is_online" -NotePropertyValue $isOnline
        $tempObject | Add-Member -NotePropertyName "CPPM_dato" -NotePropertyValue $now

        $enheter += $tempObject

        $localMacs.Remove($mac)

        Write-Progress -Activity "Lager CPPM-enheter..." -Status "Utført: $i av $count" -PercentComplete (($i / $count) * 100)
    }
    $enheter
}