########## Script for oppsett av database og servicebruker

#####################  ENDRE PÅ DETTE! ########################
# Navn på server:
$SQLServer = "da-test-sql.database.windows.net"
# Navn på Master DB for å opprette en login:
$dbMaster = "master"
# Navn på databasen som skal benyttes:
$dbNavn = "da-test-sql"
# Porten som skal benyttes:
$port = 1433
# Brukernavn til nettsideBruker:
$nettsideBrukernavn = "NettsideBruker"
# Passordet til nettsideBruker:
$nettsideBrukerPwd = "Domstol2019!"
##############################################################

$Sti = ($PSScriptRoot + "\secret\DatabaseSecret.txt" )
# Lager et objekt bestående av de truslene det letes etter samt litt info om hver trussel:
$Trusler = @([PSCustomObject]@{Type = "Uadministrert"; Info = "Finner ikke data om denn enheten i SCCM. Enheten blir da ikke administrert, og kan være en trussel."},
    [PSCustomObject]@{Type = "IP-Missmatch"; Info = "IP-lokasjonen til enheten er forskjellig mellom SCCM, Airwave og Clearpass."})


Write-Host "Skriv inn Brukernavn og Passord for sqlAdmin:" -ForegroundColor Yellow
$sqlAdmin = Get-Credential -Credential $null
$sqlAdminNavn = $sqlAdmin.UserName
$sqlAdminPass = $sqlAdmin.Password | ConvertFrom-SecureString
$sqlAdminPlainPass = Unprotect-Passord $sqlAdminPass

# Tester kobling mot databasen:
$SQLConnection = Test-SqlConnection -brukernavn $sqlAdminNavn -Passord $sqlAdminPlainPass -SQLServer $SQLServer -port 1433 -DatabaseNavn $dbNavn

Write-Verbose "Sjekker om Connection mot SQLDatabase fungerer:"
if ($SQLConnection -eq $true) {

    Write-Host "Skriv inn Brukernavn og Passord for ServiceAccount i vinduet:" -ForegroundColor Yellow
    $ServiceCred = Get-Credential -Credential $null
    $ServiceCred.Password | ConvertFrom-SecureString | Out-File -FilePath $Sti
    $passString = Get-Content -Path $Sti
    $ServicePlainPass = Unprotect-Passord $passString
    $ServiceBruker = $ServiceCred.UserName

    Write-Verbose "Lager query for å opprette ny ServiceAccount"
    $nyServiceAccQuery = New-ServiceAccountAzure -ServiceAccName $ServiceBruker -ServiceAccPwd $ServicePlainPass
    Send-QueryToDatabase -Query $nyServiceAccQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbMaster

    Write-Verbose "Lager query for å opprette login for NettsideBruker"
    $nyNettsideLoginQuery = New-NettsideLogin -nettsideBrukernavn $nettsideBrukernavn -nettsideBrukerPwd $nettsideBrukerPwd
    Send-QueryToDatabase -Query $nyNettsideLoginQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbMaster

    Write-Verbose "Lager query for å opprette tabellen Enheter"
    $EnhetTabellQuery = New-SQLTableEnheter
    Send-QueryToDatabase -Query $EnhetTabellQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å opprette tabellen Trusler"
    $TruslerTabellQuery = New-SQLTableTrusler
    Send-QueryToDatabase -Query $TruslerTabellQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å opprette tabellen Enheter_Trusler"
    $EnheterTruslerQuery = New-SQLTableEnheterTrusler
    Send-QueryToDatabase -Query $EnheterTruslerQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å opprette tabellen Uthenting_SCCM"
    $UthentingSCCMQuery = New-SQLTableSCCM
    Send-QueryToDatabase -Query $UthentingSCCMQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å opprette tabellen Uthenting_CPPM"
    $UthentingCPPMQuery = New-SQLTableCPPM
    Send-QueryToDatabase -Query $UthentingCPPMQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å opprette tabellen Uthenting_AMP"
    $UthentingAMPQuery = New-SQLTableAMP
    Send-QueryToDatabase -Query $UthentingAMPQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å opprette databasebruker som kobles mot ServiceAccount"
    $DBUserForServiceAccountQuery = New-DBUserToServiceAccount -ServiceAccountName $ServiceBruker
    Send-QueryToDatabase -Query $DBUserForServiceAccountQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn
    
    Write-Verbose "Lager query for å opprette databasebruker som kobles mot NettsideBruker"
    $DBNettsideBrukerQuery = New-DBNettsideBruker -nettsideBruker $brukernavnNettside
    Send-QueryToDatabase -Query $DBNettsideBrukerQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å legge ServiceAccount til riktige roller"
    $DBUserToReadWriteRole = New-DBUserToReadWriteRoleQuery -ServiceAccountName $ServiceBruker
    Send-QueryToDatabase -Query $DBUserToReadWriteRole -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å legge NettsideBruker til riktige roller"
    $NettsideBrukerReadRole = New-NettsideBrukerReadRole -nettsideBrukernavn $nettsideBrukernavn
    Send-QueryToDatabase -Query $NettsideBrukerReadRole -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å endre på rettighetene til ServiceAccount"
    $EditServiceAccountRettigheterQuery = New-EditServiceAccountRettigheter -dbNavn $dbNavn -ServiceAccountName $ServiceBruker
    Send-QueryToDatabase -Query $EditServiceAccountRettigheterQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    Write-Verbose "Lager query for å endre på rettighetene til NettsideBruker"
    $EditNettsideBrukerRettigheterQuery = New-NettsideBrukerRettigheter -dbNavn $dbNavn -nettsideBrukernavn $nettsideBrukernavn
    Send-QueryToDatabase -Query $EditNettsideBrukerRettigheterQuery -brukernavn $sqlAdminNavn -passord $sqlAdminPlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

    # Setter en timeout slik at serviceAccount kan benyttes
    Start-Sleep -Seconds 300

    Write-Verbose "Benytter ServiceAccount til å sende inn Trusler til databasen"
    $TruslerInnsending = New-SqlQueryTrusler -Trusler $Trusler
    Send-QueryToDatabase -Query $TruslerInnsending -brukernavn $ServiceBruker -passord $ServicePlainPass -SQLServer $SQLServer -port $port -DatabaseNavn $dbNavn

} else {
    Write-Debug "SQL-Connection fungerer ikke, Tilse at riktig bruker- og serverinformasjon er lagt til  "
}



