# Funksjonen deler opp det som skal sendes til databasen. Grunnen til dette er optimalisering av SQL.
Function Group-SQLInnsending {

    [CmdletBinding()]
    # Setter de parameterne som skal til for at funksjonen fungerer. BatchSize er hvor mange enheter som befinner seg i hver batch.
    param(
        [Parameter(Mandatory)]$udeltTing,
        [Parameter()][int]$batchSize = 50
    )

    # Teller antallet før vi deler det opp i batches:
    $AntallIUdeltTing = $udeltTing.Count

    # Lager en array for de batchene som skal bli opprettet:
    $BatchContainer = @()
    # Regner ut hvor mange Batches som trengs for å dele opp antall enheter i batches på størrelsen av batchSize:
    $numberOfBatches = [math]::Ceiling($AntallIUdeltTing / $BatchSize)

    # Looper som lager ny batch hver gang en blir fyllt opp.
    For ($i = 0; $i -lt $numberOfBatches; $i++) {
        $Batch = @()
        
        # Looper gjennom enheter og legger enhet til batch så lenge det er plass i batchen
        For ($o = $i * $batchSize; ($o -lt ($i + 1) * $batchSize) -and ($o -lt $AntallIUdeltTing); $o++) {
            
            # Sjekker om siste enhet er lagt til.
            If ($o -lt $AntallIUdeltTing) {
                $Batch += $udeltTing[$o]
                Write-Debug "$o er mindre enn $AntallIUdeltTing, legger enhet inn i Batch"
            }
            Else {
                Write-Debug "$o er ikke mindre enn $AntallIUdeltTing, glemmer"
            }#End If $o -lt $antalliudeltting

        }#End For-loop

        # Legger alle Batches til array for Batches:
        $BatchContainer += , $Batch
        # Teller over hvor mange Batches som er laget:
        $batchcontCount = $BatchContainer.Count
        Write-Verbose "BatchContainer inneholder $batchcontCount enheter"
        $testcounter = 0
        foreach ($batch in $BatchContainer) {
            Write-Verbose "Innholdet i batch $testcounter er $batch"
            $testcounter++
        }
    }


    $BatchContainer

}#End Function