# Funksjonen tilpasser AMP-data slik at det matcher databasen. Til slutt returneres spørringen for å sende inn data til databasen.
Function New-SqlQueryAMP{

    [CmdletBinding()]

    # Parameteret som hentes inn er AMP-data som skal sendes inn til databasen.
    param($Innsending)
    
    # Navnet på tabellen i databasen:
    $TabellNavn = "Uthenting_AMP"

    # Lager et tomt array som fylles med en og en formatert enhet.
    $allValues = @()

    Write-Verbose "Går gjennom hver AMP-enhet og formaterer SQL-streng"
    foreach ($e in $Innsending){
        $MAC = $e.AMP_Mac
        $ConnectTime = $e.AMP_Connect_Time
        $IP = $e.AMP_Lan_Ips
        $IPLok = $e.AMP_IPLok
        $Hostnames = $e.AMP_Lan_Hostnames
        $AP_ID = $e.AMP_Ap_Id
        $AP_Name = $e.AMP_Ap_Name
        $AP_Radio_Description = $e.AMP_Radio_Description
        $Aruba_Device_Type = $e.AMP_Aruba_Device_Type
        $Asset_Category = $e.AMP_Asset_Category
        $Asset_Group = $e.AMP_Asset_Group
        $Device_Manufacturer = $e.AMP_Device_Manufacturer
        $Device_Model = $e.AMP_Device_Model
        $Device_OS = $e.AMP_Device_Os
        $Device_OS_Detail = $e.AMP_Device_Os_Detail
        $Device_Type = $e.AMP_Device_Type
        $Duration = $e.AMP_Duration
        $EAP_Supplicant = $e.AMP_Eap_Supplicant
        $Forward_Mode = $e.AMP_Forward_Mode
        $HT_Mode = $e.AMP_Ht_Mode
        $Is_Guest_User = $e.AMP_Is_Guest_User
        $Network_Chipset = $e.AMP_Network_Chipset
        $Network_Driver = $e.AMP_Network_Driver
        $Network_Vendor = $e.AMP_Network_Vendor
        $Radio_Mode = $e.AMP_Radio_Mode
        $Report_ID = $e.AMP_Report_Id
        $Role = $e.AMP_Role
        $SNMP_Trap_Source = $e.AMP_Snmp_Trap_Source
        $SSID = $e.AMP_Ssid
        $Username = $e.AMP_Username
        $Visualrf_Location = $e.AMP_Visualrf_Location
        $VLAN = $e.AMP_Vlan
        $Dato = $e.AMP_Dato
        
        # Viktig at rekkefølgen her stemmer med $atributter som er 5 linjer under.
        $eValues = "'$MAC', '$ConnectTime', '$IP', '$IPLok', '$Hostnames', '$AP_ID', '$AP_Name', '$AP_Radio_Description', '$Aruba_Device_Type', '$Asset_Category', '$Asset_Group', '$Device_Manufacturer', '$Device_Model', '$Device_OS', '$Device_OS_Detail', '$Device_Type', '$Duration', '$EAP_Supplicant', '$Forward_Mode', '$HT_Mode', '$Is_Guest_User', '$Network_Chipset', '$Network_Driver', '$Network_Vendor', '$Radio_Mode', '$Report_ID', '$Role', '$SNMP_Trap_Source', '$SSID', '$Username', '$Visualrf_Location', '$VLAN', '$Dato'"
        $allValues += $eValues
        Write-Debug "Enheten får følgende SQL-streng: $eValues"
    }
    # $atributter må stemme med rekkefølgen i databasen.
    $atributter = "MAC, AMP_Connect_Time, AMP_Lan_IPs, AMP_IPLok, AMP_LAN_Hostnames, AMP_AP_ID, AMP_AP_Name, AMP_AP_Radio_Description, AMP_Aruba_Device_Type, AMP_Asset_Category, AMP_Asset_Group, AMP_Device_Manufacturer, AMP_Device_Model, AMP_Device_OS, AMP_Device_OS_Detail, AMP_Device_Type, AMP_Duration, AMP_EAP_Supplicant, AMP_Forward_Mode, AMP_HT_Mode, AMP_Is_Guest_User, AMP_Network_Chipset, AMP_Network_Driver, AMP_Network_Vendor, AMP_Radio_Mode, AMP_Report_ID, AMP_Role, AMP_SNMP_Trap_Source, AMP_SSID, AMP_Username, AMP_Visualrf_Location, AMP_VLAN, AMP_Dato"
    $count = 0
    $max = $allValues.Count

    # Lager et tomt array for ferdig formatert enhetsinformasjon
    $fullValue = @()

    Write-Verbose "Formaterer SQL-streng slik at det blir komma mellom values og avsluttes med semikolon"
    foreach ($v in $allValues) {
        $count += 1

        $value = "($v)"

        if($count -lt $max){
            $value += ","
        }elseif($count -eq $max){
            $value += ";"
        }

        $fullValue += $value

    }
    
    # Lager sql-spørringen for å sende inn AMP-data til databasen.
    $Start = "INSERT INTO $TabellNavn ($atributter) VALUES $fullValue"

    # Returnerer spørringen:
    $Start
}
