# Funksjonen tilpasser enhets-data slik at det matcher databasen. Til slutt returneres spørringen for å sende inn data til databasen.
Function New-SqlQueryEnheter{

    [CmdletBinding()]

    # Parameteret som hentes inn er enhets-data som skal sendes inn til databasen.
    param($Enheter)
    
    # Navnet på tabellen i databasen:
    $TabellNavn = "Enheter"

    # Lager et tomt array som fylles med en og en formatert enhet.
    $allValues = @()

    Write-Verbose "Går gjennom hver enhet og formaterer SQL-streng"
    foreach ($e in $Enheter){
        $eValues = "'$e'"
        $allValues += $eValues
        Write-Debug "Enheten får følgende SQL-streng: $eValues"
    }

    $atributter = "MAC"
    $count = 0
    $max = $allValues.Count

    # Lager et tomt array for ferdig formatert enhetsinformasjon
    $fullValue = @()

    Write-Verbose "Formaterer SQL-streng slik at det blir komma mellom values og avsluttes med semikolon"
    foreach ($v in $allValues) {
        $count += 1

        $value = "($v)"

        if($count -lt $max){
            $value += ","
        }elseif($count -eq $max){
            $value += ";"
        }

        $fullValue += $value

    }
    
    # Lager sql-spørringen for å sende inn CPPM-data til databasen.
    $Start = "INSERT INTO $TabellNavn ($atributter) VALUES $fullValue"

    # Returnerer spørringen:
    $Start
}
