# Funksjonen tilpasser SCCM-data slik at det matcher databasen. Til slutt returneres spørringen for å sende inn data til databasen.
Function New-SqlQuerySCCM{

    [CmdletBinding()]

    # Parameteret som hentes inn er SCCM-data som skal sendes inn til databasen.
    param($Innsending)
    
    # Navnet på tabellen i databasen:
    $TabellNavn = "Uthenting_SCCM"

    # Lager et tomt array som fylles med en og en formatert enhet.
    $allValues = @()

    Write-Verbose "Går gjennom hver SCCM-enhet og formaterer SQL-streng"
    foreach ($e in $Innsending){
        $MAC = $e.SCCM_MAC
        $OtherMACs = $e.SCCM_OtherMACs
        $AgentName = $e.SCCM_AgentName
        $AgentTime = $e.SCCM_AgentTime
        $ClientVersion = $e.SCCM_ClientVersion
        $IP = $e.SCCM_IPAddresses
        $LastLogonTime = $e.SCCM_LastLogonTimeStamp
        $LastUser = $e.SCCM_LastLogonUserName
        $Name = $e.SCCM_Name
        $OS = $e.SCCM_OperatingSystemNameandVersion
        $ResourceID = $e.SCCM_ResourceID
        $SID = $e.SCCM_SID
        $IPLok = $e.SCCM_IPLok
        $Dato = $e.SCCM_dato
    
        # Viktig at rekkefølgen her stemmer med $atributter som er 5 linjer under.
        $eValues = "'$MAC', '$OtherMACs', '$AgentName', '$AgentTime', '$ClientVersion', '$IP', '$LastLogonTime', '$LastUser', '$Name', '$OS', '$ResourceID', '$SID', '$IPLok', '$Dato'"
        $allValues += $eValues
        Write-Debug "Enheten får følgende SQL-streng: $eValues"
    }
     # $atributter må stemme med rekkefølgen i databasen.
    $atributter = "MAC, SCCM_OtherMACs, SCCM_AgentName, SCCM_AgentTime, SCCM_ClientVersion, SCCM_IPAddresses, SCCM_LastLogonTimeStamp, SCCM_LastLogonUserName, SCCM_Name, SCCM_OperatingSystemNameandVersion, SCCM_ResourceID, SCCM_SID, SCCM_IPLok, SCCM_Dato"
    $count = 0
    $max = $allValues.Count

    # Lager et tomt array for ferdig formatert enhetsinformasjon
    $fullValue = @()

    Write-Verbose "Formaterer SQL-streng slik at det blir komma mellom values og avsluttes med semikolon"
    foreach ($v in $allValues) {
        $count += 1

        $value = "($v)"

        if($count -lt $max){
            $value += ","
        }elseif($count -eq $max){
            $value += ";"
        }

        $fullValue += $value

    }
    
    # Lager sql-spørringen for å sende inn SCCM-data til databasen.
    $Start = "INSERT INTO $TabellNavn ($atributter) VALUES $fullValue"
    
    # Returnerer spørringen:
    $Start
}
