# Funksjonen tilpasser trussel-data slik at det matcher databasen. Til slutt returneres spørringen for å sende inn data til databasen.
Function New-SqlQueryTrusler{
    
    [CmdletBinding()]

    # Parameteret som hentes inn er truslene som skal sendes inn til databasen.
    param($Trusler)

    # Navnet på tabellen i databasen:
    $TabellNavn = "Trusler"

    # Lager et tomt array som fylles med en og en formatert Trusel.
    $allValues = @()

    Write-Verbose "Går gjennom trusel og formaterer SQL-streng"
    foreach ($e in $Trusler){
        $Type = $e.Type
        $Info = $e.Info

        $eValues = "'$Type', '$Info'"
        $allValues += $eValues
        Write-Debug "Trusselen får følgende SQL-streng: $eValues"
    }

    $atributter = "Type, Info"
    $count = 0
    $max = $allValues.Count

    # Lager et tomt array for ferdig formatert trusel-informasjon
    $fullValue = @()

    Write-Verbose "Formaterer SQL-streng slik at det blir komma mellom values og avsluttes med semikolon"
    foreach ($v in $allValues) {
        $count += 1

        $value = "($v)"

        if($count -lt $max){
            $value += ","
        }elseif($count -eq $max){
            $value += ";"
        }

        $fullValue += $value

    }
    
    # Lager sql-spørringen for å sende inn trusler til databasen.
    $Start = "INSERT INTO $TabellNavn ($atributter) VALUES $fullValue"

    # Returnerer spørringen:
    $Start
}
