# Funksjonen benyttes for å sende spørringer mot databasen.
Function Send-QueryToDatabase{

    [CmdletBinding()]

    # Parameterne som benyttes er spørringen som skal sendes til databasen og info om databasen og bruker for oppkobling.
    param([String]$Query, $brukernavn, $passord, $SQLServer, $port, $DatabaseNavn)

    # Strengen som benyttes for å nå databasen. MÅ ENDRES DERSOM DET IKKE ER EN AZURE-DATABASE!!!
    $connectionString = "Server=tcp:$SQLServer,$port;Initial Catalog=$DatabaseNavn;Persist Security Info=False;User ID=$brukernavn;Password=$passord;MultipleActiveResultSets=False;Encrypt=True;TrustServerCertificate=False;Connection Timeout=30;"

    # Oppretter koblingen:
    $SqlConnection = New-Object System.Data.SqlClient.SqlConnection
    $SqlConnection.ConnectionString = $connectionString

    # Gjør at spørringen kan sendes inn til databasen:
    $SqlCmd = New-Object System.Data.SqlClient.SqlCommand
    $SqlCmd.CommandText = $Query
    $SqlCmd.Connection = $SqlConnection

    # Adapter som benyttes til å fylle dataset:
    $SqlAdapter = New-Object System.Data.SqlClient.SqlDataAdapter
    $SqlAdapter.SelectCommand = $SqlCmd

    # Dataset bestående av data som ble etterspurt:
    $DataSet = New-Object System.Data.DataSet
    $SqlAdapter.Fill($DataSet) | Out-Null

    # Kobler fra databasen:
    $SqlConnection.Close()

    Write-Verbose "Sjekker om data ble hentet fra databasen"
    if($DataSet.Tables[0].rows.Count -ne 0){
        Write-Debug "Datasett ble hentet fra databasen"
        $DataSet.Tables[0]
    }else{
        Write-Debug "Ingen data ble hentet fra databasen"
    }
}
