# Funksjon for å teste koblingen mot databasen.
function Test-SqlConnection {

    [CmdletBinding()]
    
    # Parameterne som benyttes er login credentials og oppkoblingsinfo om databasen.
    param($brukernavn, $Passord, $SQLServer, $port, $DatabaseNavn)
    
    $ErrorActionPreference = 'Stop'

    Write-Verbose "Tester SQL-Connection for Brukeren $brukernavn"
    try {
        $connectionString = "Server=tcp:$SQLServer,$port;Initial Catalog=$DatabaseNavn;Persist Security Info=False;User ID=$brukernavn;Password=$Passord;MultipleActiveResultSets=False;Encrypt=True;TrustServerCertificate=False;Connection Timeout=30;"
        $sqlConnection = New-Object System.Data.SqlClient.SqlConnection $ConnectionString
        $sqlConnection.Open()

        Write-Debug "SQL-Connection = True"
        $true
    } catch {
        Write-Debug "SQL-Connection = False"
        $false
    } finally {
        # Lukker koblingen mot databasen.
        $sqlConnection.Close()
    } 
}
