<#
    .synopsis
    Funksjonen henter ip-addresser og lokasjoner fra et xlsx-dokument, og returnerer et hashtable med ip-addressene og relaterte lokasjoner

    .description
    Funksjonen tar inn en path til et .xlsx-dokument som inneholder DHCP-scopes. Deretter brukes modulen psexcel for å hente informasjonen som er lagret, og
    funksjonen tar ut ip-scopes og lokasjon, som returneres som et hashtable.

    .outputs
    @{'10.0.0.', 'BERGEN'; '10.1.0.', 'OSLO'}
#>
Function Format-IPtable {

    param($path)

    Write-Debug $path

    Import-Module psexcel

    $Excel = Import-XLSX -Path $path

    $IPTable = @{}

    $IP = $Excel | Select-Object scope, kortnavn

    foreach ($i in $ip) {
        $scope = $i.scope
        $scopesplit = $scope.split(".")
        $trail = $scopesplit[3]
        $traillength = $trail.length
        $length = $scope.length
        $scope = $scope.substring(0, ($length-$traillength))

        $IPTable.Add($scope, $i.kortnavn)   
    }

    $IPTable
    
}