# Funksjon som tester om ønsket lagringsplass eksisterer. Lager mappe dersom det ikke gjør det.
Function Test-Lagringsplass{

    [CmdletBinding()]
    
    # Setter de parametrene som skal brukes:
    param([String]$Lagringsplass, [String]$MappeNavn)

    $FullSti = $Lagringsplass + $MappeNavn

    $Mappetest = Test-Path -Path "$Lagringsplass\$MappeNavn"
    Write-Verbose ("Tester pathen $FullSti")

    # Tester om stien eksisterer:
    if($Mappetest -eq $True){
        Write-Verbose "Ønsket lagringsplass eksisterer allerede"
    }
    else{
        # Lager stien hvis den ikke eksisterer
        try{
            New-Item -Path $Lagringsplass -Name $MappeNavn -ItemType "directory" | Out-Null
        }
        catch{"Noe gikk galt ved opprettelse av lagringsplass"}
        Write-Verbose "Ønsket lagringsplass er opprettet"
    }
        
}
