<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Finn enkeltenhet</title>

    <!-- Custom fonts for this template-->
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link
        href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
        rel="stylesheet">

    <!-- Custom styles for this template-->
    <link href="css/sb-admin-2.min.css" rel="stylesheet">

    <script>
        function checkMac(mac){
            var regex = /^([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$/;
            return regex.test(mac);
        }

        function start(){
            var $mac = ""
            try {
                $mac = "<?php echo htmlspecialchars($_GET['mac']) ?>";
            } catch (error) {
                $mac = ""
            }
            
            if(checkMac($mac)){
                sok($mac);
            }
        }

        function sok(mac){
            getenhet(mac, 'uthenting_SCCM', 'dataTableSCCM');
            getenhet(mac, 'uthenting_AMP', 'dataTableAMP');
            getenhet(mac, 'uthenting_CPPM', 'dataTableCPPM');
        }
    </script>

</head>

<body id="page-top" onload="start()">

    <!-- Page Wrapper -->
    <div id="wrapper">

                <!-- Sidebar -->
                <ul class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion" id="accordionSidebar">

<!-- Sidebar - Brand -->
<a class="sidebar-brand d-flex align-items-center justify-content-center" href="index.html">
    <div class="sidebar-brand-text mx-3">EnVy</div>
</a>

<!-- Divider -->
<hr class="sidebar-divider my-0">

<!-- Nav Item - Dashboard -->
<li class="nav-item">
    <a class="nav-link" href="index.html">
        <i class="fas fa-fw fa-tachometer-alt"></i>
        <span>Dashboard</span></a>
</li>

<!-- Divider -->
<hr class="sidebar-divider">

<!-- Heading -->
<div class="sidebar-heading">
    Enheter
</div>

<!-- Nav Item - Søk i enheter -->
<li class="nav-item">
    <a class="nav-link" href="nyesteinfo.php">
        <i class="fas fa-fw fa-info"></i>
        <span>Mest oppdaterte informasjon</span></a>
</li>

<li class="nav-item active">
    <a class="nav-link" href="finnEnkeltenhet.php">
        <i class="fas fa-fw fa-search"></i>
        <span>Finn enheter</span></a>
</li>

<li class="nav-item">
    <a class="nav-link" href="sccmdata.php">
        <i class="fas fa-fw fa-chart-area"></i>
        <span>SCCM-data</span>
    </a>
</li>

<!-- Divider -->
<hr class="sidebar-divider">

            <!-- Heading -->
            <div class="sidebar-heading">
                Trusler
            </div>

<li class="nav-item">
    <a class="nav-link" href="EnheterTrusler.html">
        <i class="fas fa-fw fa-bomb"></i>
        <span>Trusler</span>
    </a>
</li>

<li class="nav-item">
    <a class="nav-link" href="TruslerGraf.html">
        <i class="fas fa-fw fa-radiation"></i>
        <span>Grafer for trusler</span>
    </a>
</li>



<!-- Divider -->
<hr class="sidebar-divider d-none d-md-block">

<!-- Sidebar Toggler (Sidebar) -->
<div class="text-center d-none d-md-inline">
    <button class="rounded-circle border-0" id="sidebarToggle"></button>
</div>

</ul>
<!-- End of Sidebar -->

        <!-- Content Wrapper -->
        <div id="content-wrapper" class="d-flex flex-column">

            <!-- Main Content -->
            <div id="content">

                <!-- Begin Page Content -->
                <div class="container-fluid">

                    <!-- Page Heading -->
                    <h1 class="h3 mb-4 text-gray-800">Informasjon om enkeltenheter</h1>

                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">Skriv inn MAC du vil søke etter:</h6>
                        </div>
                        <div class="card-body">
                            MAC: <input type="text" id="macinput">
                            <input type="submit" onclick="sok(document.getElementById('macinput').value)">
                        </div>
                    </div>

                    <!-- DataTales SCCM Example -->
                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">SCCM</h6>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTableSCCM" width="100%" cellspacing="0">
                                    
                                </table>
                            </div>
                        </div>
                    </div>

                    <!-- DataTales AMP Example -->
                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">Aruba Airwave</h6>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTableAMP" width="100%" cellspacing="0">
                                    
                                </table>
                            </div>
                        </div>
                    </div>

                    <!-- DataTales CPPM Example -->
                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">Aruba Clearpass</h6>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTableCPPM" width="100%" cellspacing="0">
                                    
                                </table>
                            </div>
                        </div>
                    </div>

                </div>
                <!-- /.container-fluid -->

            </div>
            <!-- End of Main Content -->

            <!-- Footer -->
            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <span>Copyright &copy; Domstoladministrasjonen 2019</span>
                    </div>
                </div>
            </footer>
            <!-- End of Footer -->

        </div>
        <!-- End of Content Wrapper -->

    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
        <i class="fas fa-angle-up"></i>
    </a>

    <!-- Bootstrap core JavaScript-->
    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>

    <!-- Core plugin JavaScript-->
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Custom scripts for all pages-->
    <script src="js/sb-admin-2.min.js"></script>
    <script src="js/hentfraDatabase.js"></script>

    <!-- Page level plugins -->
    <script src="vendor/datatables/jquery.dataTables.min.js"></script>
    <script src="vendor/datatables/dataTables.bootstrap4.min.js"></script>

    <!-- Page level custom scripts -->
    <script src="js/datatables-init.js"></script>

</body>

</html>