// Denne funksjonen er en modifikasjon av SB Admin 2 sin pie-chart-demo. Denne benytter seg av Charts.js, for å lage et pie-chart. Funksjonen makeChart
// Tar inn filepath til en PHP-query som skal hente dataen, divID til plasseringen til chartet, og divID til plasseringen av listen med datapunkter.
// Denne blir brukt til å lage et chart over hvilke OS som finnes i hver uthenting, og har derfor kode for å legge inn unknown OS.

// Set new default font family and font color to mimic Bootstrap's default styling
Chart.defaults.global.defaultFontFamily = 'Nunito', '-apple-system,system-ui,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif';
Chart.defaults.global.defaultFontColor = '#858796';

function makeChart($queryPHP, $chartID, $listID) {

    //Funksjon som vil doble størrelsen på fargekartet dersom det ble hentet ut flere OS enn mengden som originalt var i fargekartet.
    function recColortable(colorarray, labelslength) {
        var colorarraylength = colorarray.length;
        if (colorarraylength >= labelslength) {
            return;
        } else {
            colorarray.forEach(element => {
                colorarray.push(element);
            });
            recColortable(colorarray, labelslength);
        }
    }

    var $labels = [];
    var $dat = [];

    var $bgcolors = [
        '#ff5e97',
        '#f57d1b',
        '#a57afa',
        '#7d8efa',
        '#589ffc',
        '#28c0de',
        '#28c7b7',
        '#28d17c',
        '#7eb524',
        '#ffdc2e',
        '#ab8c82',
        '#9e9e9e',
        '#76838f'
    ];
    var $hovercolors = [
        '#f74584',
        '#eb6709',
        '#9463f7',
        '#667afa',
        '#3e8ef7',
        '#0bb2d4',
        '#17b3a3',
        '#11c26d',
        '#6da611',
        '#ffcd17',
        '#997b71',
        '#757575',
        '#256069'
    ];

    // Hent informasjon fra databasen
    $.get($queryPHP, function (data, status) {
        var sporr = JSON.parse(data)
        var check = status;


        for (let index = 0; index < sporr.length; index++) {
            $os = sporr[index].os;
            $count = sporr[index].antall;

            if($os == ""){
                $os = "Unknown";
            };

            $labels.push($os);
            $dat.push($count);
        }

        recColortable($bgcolors, $labels.length);
        recColortable($hovercolors, $hovercolors.length)

        // Pie Chart Example
        var ctx = document.getElementById($chartID);
        var myPieChart = new Chart(ctx, {
            type: 'doughnut',
            data: {
                labels: $labels,
                datasets: [{
                    data: $dat,
                    backgroundColor: $bgcolors,
                    hoverBackgroundColor: $hovercolors,
                    hoverBorderColor: "rgba(234, 236, 244, 1)",
                }],
            },
            options: {
                maintainAspectRatio: false,
                tooltips: {
                    backgroundColor: "rgb(255,255,255)",
                    bodyFontColor: "#858796",
                    borderColor: '#dddfeb',
                    borderWidth: 1,
                    xPadding: 15,
                    yPadding: 15,
                    displayColors: false,
                    caretPadding: 10,
                },
                legend: {
                    display: false
                },
                cutoutPercentage: 30,
            },
        });

        $custominner = ""

        for (let index = 0; index < $labels.length; index++) {
            const label = $labels[index];
            const col = $bgcolors[index];

            $custominner += '<span class="mr-2" style="color:'
            $custominner += col;
            $custominner += '">\n<i class="fas fa-circle"></i> ';
            $custominner += label;
            $custominner += '\n</span>\n'

        }

        document.getElementById($listID).innerHTML = $custominner;

    });



};

